> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rockapi.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create chat completion

> Create a model response from the conversation history. This endpoint is fully compatible with the OpenAI Chat Completions specification, supporting multi-turn conversations, tool calls (function calling), vision inputs, and reasoning models. Supports both Server-Sent Events (SSE) for streaming and standard JSON for non-streaming responses.

Fully compatible with the OpenAI Chat Completions API, allowing you to use existing OpenAI SDKs and tools without code changes.




## OpenAPI

````yaml /vi/api-reference/openapi.json post /v1/chat/completions
openapi: 3.0.1
info:
  title: Rock API API mô hình AI
  version: 1.0.0
  description: Tham chiếu API mô hình AI tương thích OpenAI cho Rock API.
servers:
  - url: https://rockapi.ai
security:
  - BearerAuth: []
tags:
  - name: List models
  - name: OpenAI format (Chat)
  - name: OpenAI format (Responses)
  - name: Image generation
  - name: Image generation/OpenAI-compatible format
  - name: Image generation/Qwen
  - name: Video generation
  - name: Video generation/Sora-compatible format
  - name: Video generation/Kling format
  - name: Video generation/Jimeng format
  - name: Claude format (Messages)
  - name: Gemini format
  - name: OpenAI format (Embeddings)
  - name: Text completions
  - name: OpenAI audio
  - name: Rerank
  - name: Moderations
  - name: Realtime
  - name: Not implemented
  - name: Not implemented/Fine-tunes
  - name: Not implemented/Files
paths:
  /v1/chat/completions:
    post:
      tags:
        - OpenAI format (Chat)
      summary: Create chat completion
      description: >
        Create a model response from the conversation history. This endpoint is
        fully compatible with the OpenAI Chat Completions specification,
        supporting multi-turn conversations, tool calls (function calling),
        vision inputs, and reasoning models. Supports both Server-Sent Events
        (SSE) for streaming and standard JSON for non-streaming responses.


        Fully compatible with the OpenAI Chat Completions API, allowing you to
        use existing OpenAI SDKs and tools without code changes.
      operationId: createChatCompletion
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ChatCompletionRequest'
        required: true
      responses:
        '200':
          description: Response created successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ChatCompletionResponse'
          headers: {}
        '400':
          description: Invalid request parameters
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          headers: {}
        '429':
          description: Rate limit exceeded
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          headers: {}
      deprecated: false
      security:
        - BearerAuth: []
components:
  schemas:
    ChatCompletionRequest:
      type: object
      required:
        - model
        - messages
      properties:
        model:
          type: string
          description: Model ID
          example: gpt-4
        messages:
          type: array
          items:
            $ref: '#/components/schemas/Message'
          description: List of conversation messages
        temperature:
          type: number
          minimum: 0
          maximum: 2
          default: 1
          description: Sampling temperature
        top_p:
          type: number
          minimum: 0
          maximum: 1
          default: 1
          description: Nucleus sampling parameter
        'n':
          type: integer
          minimum: 1
          default: 1
          description: Number of generations
        stream:
          type: boolean
          default: false
          description: Whether to stream the response
        stream_options:
          type: object
          properties:
            include_usage:
              type: boolean
        stop:
          oneOf:
            - type: string
            - type: array
              items:
                type: string
          description: Stop sequences
        max_tokens:
          type: integer
          description: Maximum generated tokens
        max_completion_tokens:
          type: integer
          description: Maximum completion tokens
        presence_penalty:
          type: number
          minimum: -2
          maximum: 2
          default: 0
        frequency_penalty:
          type: number
          minimum: -2
          maximum: 2
          default: 0
        logit_bias:
          type: object
          additionalProperties:
            type: number
          properties: {}
        user:
          type: string
        tools:
          type: array
          items:
            $ref: '#/components/schemas/Tool'
        tool_choice:
          oneOf:
            - type: string
              enum:
                - none
                - auto
                - required
            - type: object
              properties:
                type:
                  type: string
                function:
                  type: object
                  properties:
                    name:
                      type: string
        response_format:
          $ref: '#/components/schemas/ResponseFormat'
        seed:
          type: integer
        reasoning_effort:
          type: string
          enum:
            - low
            - medium
            - high
          description: Reasoning effort (for models that support reasoning)
        modalities:
          type: array
          items:
            type: string
            enum:
              - text
              - audio
        audio:
          type: object
          properties:
            voice:
              type: string
            format:
              type: string
    ChatCompletionResponse:
      type: object
      properties:
        id:
          type: string
        object:
          type: string
          example: chat.completion
        created:
          type: integer
        model:
          type: string
        choices:
          type: array
          items:
            type: object
            properties:
              index:
                type: integer
              message:
                $ref: '#/components/schemas/Message'
              finish_reason:
                type: string
                enum:
                  - stop
                  - length
                  - tool_calls
                  - content_filter
        usage:
          $ref: '#/components/schemas/Usage'
        system_fingerprint:
          type: string
    ErrorResponse:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
              description: Error message
            type:
              type: string
              description: Error type
            param:
              type: string
              description: Related parameter
              nullable: true
            code:
              type: string
              description: Error code
              nullable: true
    Message:
      type: object
      required:
        - role
        - content
      properties:
        role:
          type: string
          enum:
            - system
            - user
            - assistant
            - tool
            - developer
          description: Message role
        content:
          oneOf:
            - type: string
            - type: array
              items:
                $ref: '#/components/schemas/MessageContent'
          description: Message content
        name:
          type: string
          description: Sender name
        tool_calls:
          type: array
          items:
            $ref: '#/components/schemas/ToolCall'
        tool_call_id:
          type: string
          description: Tool call ID (for messages with the tool role)
        reasoning_content:
          type: string
          description: Reasoning content
    Tool:
      type: object
      properties:
        type:
          type: string
          example: function
        function:
          type: object
          properties:
            name:
              type: string
            description:
              type: string
            parameters:
              type: object
              description: Parameter definition in JSON Schema format
              properties: {}
    ResponseFormat:
      type: object
      properties:
        type:
          type: string
          enum:
            - text
            - json_object
            - json_schema
        json_schema:
          type: object
          description: JSON Schema definition
          properties: {}
    Usage:
      type: object
      properties:
        prompt_tokens:
          type: integer
          description: Prompt tokens
        completion_tokens:
          type: integer
          description: Completion tokens
        total_tokens:
          type: integer
          description: Total tokens
        prompt_tokens_details:
          type: object
          properties:
            cached_tokens:
              type: integer
            text_tokens:
              type: integer
            audio_tokens:
              type: integer
            image_tokens:
              type: integer
        completion_tokens_details:
          type: object
          properties:
            text_tokens:
              type: integer
            audio_tokens:
              type: integer
            reasoning_tokens:
              type: integer
    MessageContent:
      type: object
      properties:
        type:
          type: string
          enum:
            - text
            - image_url
            - input_audio
            - file
            - video_url
        text:
          type: string
        image_url:
          type: object
          properties:
            url:
              type: string
              description: Image URL or base64
            detail:
              type: string
              enum:
                - low
                - high
                - auto
        input_audio:
          type: object
          properties:
            data:
              type: string
              description: Base64-encoded audio data
            format:
              type: string
              enum:
                - wav
                - mp3
        file:
          type: object
          properties:
            filename:
              type: string
            file_data:
              type: string
            file_id:
              type: string
        video_url:
          type: object
          properties:
            url:
              type: string
    ToolCall:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          example: function
        function:
          type: object
          properties:
            name:
              type: string
            arguments:
              type: string
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: |
        Authenticate with a Bearer Token.
        Format: `Authorization: Bearer sk-xxxxxx`

````